.nolist
#include	"ti83plus.inc"
#include	"mirage.inc"
#define bcall(label) RST 28h \ .dw label
PlayerX		.equ	AppBackUpScreen+1
PlayerY		.equ	AppBackUpScreen+2
E1X			.equ	AppBackUpScreen+3
E1Y			.equ	AppBackUpScreen+4
E2X			.equ	AppBackUpScreen+5
E2Y			.equ	AppBackUpScreen+6
E3X			.equ	AppBackUpScreen+7
E3Y			.equ	AppBackUpScreen+8
E4X			.equ	AppBackUpScreen+9
E4Y			.equ	AppBackUpScreen+10
E5X			.equ	AppBackUpScreen+11
E5Y			.equ	AppBackUpScreen+12
temp		.equ	AppBackUpScreen+90
score		.equ	AppBackUpscreen+100
dispplayer	.equ	AppBackUpscreen+102
speed		.equ	AppBackUpScreen+103
candec		.equ	AppBAckupscreen+104
startfrom	.equ	AppBackUpscreen+105
slowdown	.equ	AppBackUPscreen+107
spacing		.equ	AppBackUpScreen+109
Enemies		.equ	AppBackUpscreen+110

.list
	.org	$9d93				
	.db	$BB,$6D				
	ret					
	.db	1				
	.db	%01100000,%00000110		
	.db	%01100000,%00000110
	.db	%01110000,%00001110
	.db	%01110011,%11001110
	.db	%01111011,%11011110
	.db	%00111111,%11111100
	.db	%00111111,%11111100
	.db	%01111111,%11111110
	.db	%01111111,%11111110
	.db	%00111111,%11111100
	.db	%00111111,%11111100
	.db	%00111110,%01111100
	.db	%01111110,%01111110
	.db	%11111100,%00111111
	.db	%11111000,%00011111
	.db	"Star Wars Pod Racer",0

Menu:
	bcall(_clrlcdfull)
	bcall(_runindicoff)
	bcall(_homeup)
	ld hl,MsgMenu
	bcall(_puts)
	ld a,3
	ld (currow),a
	ld a,0
	ld (curcol),a
	ld a,'>'
	bcall(_PutMap)
Menuloop:
  bcall(_getcsc)
  cp skup
  call z,up
  cp skenter
  jr z,hitenter
  cp skclear
  jp z,quitgame
  cp sk2nd
  jp z,hitenter
  cp sk1
  jr z,Mendifficulty
  cp sk2
  jp z,instructions
  cp sk3
  jp z,quitgame
  cp skdown
  jr nz,Menuloop
down:
  ld hl,currow
  ld a,(hl)
  cp 5
  jr z,Menuloop
  ld a,' '
  bcall(_putmap)
  inc (hl)
  ld hl,Menuloop
  push hl
  jr displayIt
up:
  ld hl,currow
  ld a,(hl)
  cp 3
  jr z,Menuloop
  ld a,' '
  bcall(_putmap)
  dec (hl)
displayIt:
  ld a,'>'
  bcall(_putmap)
  ret 
	
hitenter:
	ld a,(currow)
	cp 4
	jp z, instructions
	cp 5
	jp z, quitgame
MenDifficulty:
	bcall(_clrlcdfull)
	xor a
	ld (curcol),a
	ld (currow),a
	ld hl,msgdifficulty
	bcall(_puts)
	xor a
	ld (curcol),a
	ld a,3
	ld (currow),a
	ld a,'>'
	bcall(_putmap)
mendiffloop:
  bcall(_getcsc)
  cp skup
  jr z,upd
  cp skenter
  jr z,hitenterd
  cp skclear
  jp z,Menu
  cp sk2nd
  jp z,hitenterd
  cp sk1
  jr z,setEasy
  cp sk2
  jr z,setMedium
  cp sk3
  jr z,setHard
  cp sk4
  jr z,setInsane
  cp sk5
  jp z,Menu
  cp skdown
  jp nz,Mendiffloop
downd:
  ld hl,currow
  ld a,(hl)
  cp 7
  jr z,Mendiffloop
  ld a,' '
  bcall(_putmap)
  inc (hl)
  ld hl,Mendiffloop
  push hl
  jr displayIt
upd:
  ld hl,currow
  ld a,(hl)
  cp 3
  jr z,Mendiffloop
  ld a,' '
  bcall(_putmap)
  dec (hl)
  ld hl,Mendiffloop
  push hl
  jp displayIt

hitenterd:
	ld a,(currow)
	cp 3
	jr z,setEasy
	cp 4
	jr z,setMedium
	cp 5
	jr z,setHard
	cp 6
	jr z,setInsane
	jp Menu
setEasy:
	ld a,15
	ld (spacing),a
	ld a,13
	ld (enemies),a
	jr Start
setMedium:
	ld a,10
	ld (spacing),a
	ld a,20
	ld (enemies),a
	jr Start
setHard:
	ld a,7
	ld (spacing),a
	ld a,29
	ld (enemies),a
	jr Start
setInsane:
	ld a,5
	ld (spacing),a
	ld a,37
	ld (enemies),a

Start:
	bcall(_clrlcdfull)
	bcall(_grbufclr)
	ld hl,0
	ld (score),hl
	call setup
	ld a,2
	ld (speed),a
	ld a,3
	ld (candec),a
	ld a,192
	ld (startfrom),a
	ld hl,4000
	ld (slowdown),a
gameloop:
	ld hl,(score)
	inc hl
	ld (score),hl
	call movingpic
	call displayai
	call displayplayer
	call fastercopy
	ld a,$FF
	out (1),a
	nop
	nop
	nop
	ld     a, $FE; Enable Up, Down, Left, Right
	out    (1), a
	in    a,(1)
	cp    $FE
	jr    z, movepdown
	cp    $FD
	jr    z, moveleft
	cp    $FB
	jr    z, moveright
	cp    $F7
	jr    z, moveup
	cp    $F5
	jr    z, moveupleft
	cp    $F3
	jr    z, moveupright
	cp    $FC
	jp    z, movedownleft
	cp    $FA
	jp    z, movedownright
	ld a,$FF
	out (1),a
	nop
	nop
	nop
	ld a,$FD
	out (1),a
	in  a,(1)
	cp $BF
	jp z,quit
keydone:
	call movedown
	jp gameloop
	
	
moveright:
	or a
	ld a,(PlayerX)
	cp 80
	jr nc,keydone
	inc a
	ld (PlayerX),a
	jr keydone
moveleft:
	or a
	ld a,(PlayerX)
	cp 9
	jr c,keydone
	dec a
	ld (PlayerX),a
	jr keydone
moveup:
	or a
	ld a,(PlayerY)
	cp 45
	jr c,keydone
	dec a
	ld (PlayerY),a
	jr keydone
movepdown:
	or a
	ld a,(PlayerY)
	cp 56
	jr nc,keydone
	inc a
	ld (PlayerY),a
	jr keydone
	
moveupleft:
	or a
	ld a,(PlayerX)
	cp 10
	jr c,notleft
	dec a
	ld (PlayerX),a
notleft:
	or a
	ld a,(PlayerY)
	cp 45
	jr c,keydone
	dec a
	ld (PlayerY),a
	jr keydone
	
moveupright:
	or a
	ld a,(PlayerX)
	cp 80
	jr nc,notright
	inc a
	ld (PlayerX),a
notright:
	or a
	ld a,(PlayerY)
	cp 45
	jr c,keydone
	dec a
	ld (PlayerY),a
	jr keydone
	
movedownleft:
	or a
	ld a,(PlayerX)
	cp 10
	jr c,notdleft
	dec a
	ld (PlayerX),a
notdleft:
	or a
	ld a,(PlayerY)
	cp 56
	jp nc,keydone
	inc a
	ld (PlayerY),a
	jp keydone
	
movedownright:
	or a
	ld a,(PlayerX)
	cp 80
	jr nc,notdright
	inc a
	ld (PlayerX),a
notdright:
	or a
	ld a,(PlayerY)
	cp 56
	jp nc,keydone
	inc a
	ld (PlayerY),a
	jp keydone
	
setup:
	ld a,50
	ld (PlayerX),a
	ld a,56
	ld (PlayerY),a
	call makeaix
	ld hl,E1Y
	ld a,(enemies)
	dec a
	ld b,a
	ld a,(spacing)
	ld c,a
	xor a
	ld (hl),a
restloop:
	sub c
	inc hl
	inc hl
	ld (hl),a
	djnz restloop
	ret
	
makeaix:
	ld a,(enemies)
	ld b,a
	ld hl,E1X
makeailoop:
	push bc
	push hl
	ld b,72
	call iRandom
	add a,9
	pop hl
	ld (hl),a
	inc hl
	inc hl
	pop bc
	djnz makeailoop
	ret
	
displayai:
	xor a
	ld (dispplayer),a
	ld a,(enemies)
	ld b,a
	ld hl,E1X
displayailoop:
	push bc
	ld a,(hl)
	ld b,a
	inc hl
	ld a,(hl)
	inc hl
	cp 58
	jr nc,dontdisplaythis
	ld e,a
	ld a,b
	ld c,8
	ld ix,rocks
	push hl
	call putsprite
	pop hl
dontdisplaythis:
	pop bc
	djnz displayailoop
	ret

randomizeX:
	push hl
	push af
	push bc
	dec hl
	push hl
	ld b,72
	call iRandom
	add a,9
	pop hl
	ld (hl),a
	pop bc
	pop af
	pop hl
	ret
	
	
displayplayer:
	ld a,1
	ld (dispplayer),a
	ld a,(PlayerY)
	ld e,a
	ld a,(PlayerX)
	ld c,8
	ld ix,ship
	call putsprite
	ret

movedown:
	ld a,(enemies)
	ld b,a
	ld hl,E1Y
movedownloop:
	or a
	ld a,(hl)
	add a,1
	call c,randomizeX
	ld (hl),a
	inc hl
	inc hl
	djnz movedownloop
	ret
	
	
putsprite:
;a  = xcoord
;e  = ycoord
;c  = rows
;ix = address of sprite
;must be X*8
	ld h,0
	ld d,h
	ld l,e
	add hl,hl
	add hl,de
	add hl,hl
	add hl,hl
	ld e,a
	srl e
	srl e
	srl e
	add hl,de
	ld de,plotsScreen
	add hl,de
	and 7
	jr z,aligned
	ld (temp),a
	ld b,c
	ld de,12
rowloop:
	push bc
	ld a,(temp)
	ld b,a
	ld c,(ix)
	or a
shiftloop:
	srl c
	rra
	djnz shiftloop
	inc hl
	call hitdetect
	or (hl)
	ld (hl),a
	dec hl
	ld a,c
	or (hl)
	ld (hl),a
	add hl,de
	inc ix
	pop bc
	djnz rowloop
	ret
aligned:
	ld de,12
	ld b,8
putloop:
	ld a,(ix)
	or (hl)
	ld (hl),a
	inc ix
	add hl,de
	djnz putloop
	ret

hitdetect:
	push af
	push bc
	push de
	push hl
	push af
	ld a,(dispplayer)
	or a
	jr nz,goodsofar
nohit:
	pop af
	pop hl
	pop de
	pop bc
	pop af
	ret
goodsofar:
	ld a,(hl)
	ld b,a
	pop af
	push af
	and b
	or a
	jr z,nohitsofar
	pop af
	pop hl
	pop de
	pop bc
	pop af
	jp youlose
nohitsofar:
	pop af
	pop hl
	pop de
	pop bc
	push bc
	push de
	push hl
	push af
	dec hl
	ld a,(hl)
	and c
	or a
	jr z,nohit
	pop af
	pop hl
	pop de
	pop bc
	pop af
	jp youlose
	
Ship:
	.db %01100110
	.db %01011010
	.db %01111110
	.db %01111110
	.db %00111100
	.db %00111100
	.db %01100110
	.db %11000011
Rocks:
	.db %00000000
	.db %00111100
	.db %01111110
	.db %01111110
	.db %01111110
	.db %01111110
	.db %00111100
	.db %00000000
	
youlose:
	bcall(_grbufclr)
	bcall(_clrlcdfull)
	ld hl,msgyoulose
	bcall(_homeup)
	bcall(_puts)
	ld b,100
losehaltloop:
	ei
	halt
	djnz losehaltloop
	ld hl,msgyourscore
	xor a
	ld (curcol),a
	ld a,1
	ld (currow),a
	bcall(_puts)
	ld hl,(score)
	xor a
	ld (curcol),a
	ld a,2
	ld (currow),a
	bcall(_disphl)
	bcall(_getkey)
	pop hl
	pop hl
	pop hl
	pop hl
	jp Menu
	
msgyoulose:
	.db "You lose",0
msgyourscore:
	.db "Your score:",0
	

quit:
	bcall(_grbufclr)
	jp Menu
	
movingpic:
	ld a,(startfrom)
	or a
	jr nz,pickeepgoing
	ld a,192
	ld (startfrom),a
	ld hl,Types+192
	jr picgood
pickeepgoing:
	ld e,a
	ld d,0
	ld hl,Types
	add hl,de
	sub 12
	ld (startfrom),a
picgood:
	ld de,plotsscreen
	ld b,4
picloop:
	push bc
	ld b,192
picinnerloop:
	ld a,(hl)
	cp $88
	call z,movepictotop
	ld (de),a
	inc hl
	inc de
	djnz picinnerloop
	pop bc
	djnz picloop
	ret
	
movepictotop:
	ld hl,Types
	ld a,(hl)
	ret
	
Types:
.db		$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F 
.db		$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F
.db		$F8,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1F
.db		$F8,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1F
.db		$FC,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$3F
.db		$FC,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$3F
.db		$FE,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7F
.db		$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF
.db		$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF
.db		$FE,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7F
.db		$FC,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$3F
.db		$FC,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$3F
.db		$F8,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1F
.db		$F8,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1F
.db		$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F
.db		$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$88   ;16  $88 = endbyte
	
	
quitgame:
	bcall(_clrlcdfull)
	ret
	
Instructions:
	bcall(_clrlcdfull)
	bcall(_grbufclr)
	xor a
	ld (penrow),a
	ld hl,msgInstructions
	ld b,9
instructloop:
	xor a
	ld (pencol),a
	push af
	push bc
	bcall(_vputs)
	pop bc
	pop af
	ld a,(penrow)
	add a,7
	ld (penrow),a
	djnz instructloop
	bcall(_getkey)
	jp Menu
	
msgInstructions:
	.db "You are a Jedi Pilot,",0
	.db "racing in a pod race",0
	.db "on Tatooine.  Your objective",0
	.db "is to get as far as you can",0
	.db "without crashing into",0
	.db "the rocks.",0
	.db "Good luck, and God speed!",0
	.db "Programmed by Chipmaster",0
	.db "AKA Patrick Stetter",0
	
msgMenu:
	.db "-  STAR WARS   -"
	.db "-  POD RACER   -"
	.db "----------------"
	.db " 1. START GAME  "
	.db " 2. INSTRUCTIONS"
	.db " 3. QUIT        ",0
	
msgDifficulty:
	.db "-   SELECT A   -"
	.db "-  DIFFICULTY  -"
	.db "----------------"
	.db " 1. EASY        "
	.db " 2. MEDIUM      "
	.db " 3. HARD        "
	.db " 4. INSANE      "
	.db " 5. GO BACK    ",0
	
fastercopy:
;-----> Copy the gbuf to the screen (fast)
;Input:	nothing
;Output:graph buffer is copied to the screen
	di
	ld	a,$80				; 7
	nop
	nop
	nop
	out	($10),a				; 11
	ld	hl,plotsscreen-12-(-(12*64)+1)		; 10
	ld	a,$20				; 7
	ld	c,a				; 4
	inc	hl				; 6 waste
	dec	hl				; 6 waste
fasterCopyAgain:
	ld	b,64				; 7
	inc	c				; 4
	ld	de,-(12*64)+1			; 10
	nop
	nop
	nop
	out	($10),a				; 11
	nop
	nop
	add	hl,de				; 11
	ld	de,10				; 10
fasterCopyLoop:
	add	hl,de				; 11
	inc	hl				; 6 waste
	inc	hl				; 6 waste
	inc	de				; 6
	ld	a,(hl)				; 7
	nop
	nop
	nop
	out	($11),a				; 11
	dec	de				; 6
	djnz	fasterCopyLoop			; 13/8
	ld	a,c				; 4
	cp	$2B+1				; 7
	jr	nz,fasterCopyAgain		; 10/1
	ret					; 10
; Critical timings:
;	command->command: 65
;	command->value  : 68
;	value  ->value  : 66
;	value  ->command: 67
	
	
	
.end
end